/**
 * Created by zdy on 2016/10/8.
 */

'use strict';

const Path = require('path');
const fs = require('fs');

module.exports = app => {
    // 应用中控制器目录
    const controllerDir = Path.join(app.config.baseDir, app.config._direwolfConfig.controllerDir);

    // 获取目录中的文件名
    const controllerFiles = fs.readdirSync(controllerDir);

    const controller = {};

    for (const fileName of controllerFiles) {
        const objName = Path.basename(fileName, '.js');
        const _path = Path.join(controllerDir, objName);

        // 一级对象为控制器中的文件名，二级对象为控制器中exports出来的方法
        Object.defineProperty(controller, objName, {
            get() {
                if (app.env === 'development') {// 开发态下，不缓存controller
                    require.cache[require.resolve(_path)] = null;
                }
                return require(_path);
            }
        });
    }


    app.controller = controller;
    return controller;
};