/**
 * Created by zdy on 2016/9/28.
 * 应用日志类
 */

'use strict';

const log4js = require('log4js');
const Path = require('path');
const fs = require('fs');
const direwolfConfig = require('../config/config');
const BASE_DIR = process.cwd();

class Logger {
    constructor(name) {

        // 日志目录
        this.dir = Path.join(BASE_DIR, direwolfConfig.logDir);

        // 确保日志目录存在
        if (!fs.existsSync(this.dir)) {
            fs.mkdirSync(this.dir);
        }

        log4js.configure({
            appenders: [
                // 输出到文件
                {
                    type: 'dateFile',
                    filename: Path.join(this.dir, 'log.log'),
                    pattern: '-yyyy-MM-dd'
                },
                // 输出到控制台
                {
                    type: 'console'
                }
            ]
        });

        this.logger = log4js.getLogger(name);
    }
}

module.exports = name => (new Logger(name)).logger;