/**
 * Created by zdy on 2016/10/25.
 * 全局中间件
 */

'use strict';

const Path = require('path');
const convert = require('koa-convert');
const middleware = {
    beforeAction: [],
    afterAction: []
};

module.exports = {
    init: app => {
        const middlewareConf = app.config.middleware;
        const middlewareDir = Path.join(app.config.baseDir, require('../config/config').middlewareDir);
        for (const mwName in middlewareConf) {
            const pos = middlewareConf[mwName].position;
            const path = Path.join(middlewareDir, mwName);
            const mw = require(path)(app);
            middleware[pos].push(mw);
        }
    },
    beforeAction: app => {
        for (const mw of middleware.beforeAction) {
            app.use(convert(mw));
        }
    },
    afterAction: app => {
        for (const mw of middleware.afterAction) {
            app.use(convert(mw));
        }
    }
};