/**
 * Created by zdy on 2016/10/9.
 */

'use strict';

const router = require('koa-router')();
const Path = require('path');
const convert = require('koa-convert');

module.exports = app => {

    app.router = router;

    require(Path.join(app.config.baseDir, 'router'))(app);

    // 将controller注入koa中间件中
    app.use(convert(function* (next) {
        if (app.env === 'development') {
            clearRouteCache();
        }
        yield router.routes();
        yield next;
    }));

    /**
     * 清除路由缓存
     */
    function clearRouteCache() {
        router.stack = [];
        delete require.cache[Path.join(app.config.baseDir, 'router')];
        require(Path.join(app.config.baseDir, 'router'))(app);
    }

    return router
};
